import { world, system, CommandPermissionLevel, ItemStack, ItemLockMode, EnchantmentType, CustomCommandParamType, CustomCommandStatus, CustomCommandOrigin } from "@minecraft/server";

world.afterEvents.worldLoad.subscribe(() => world.sendMessage(`§eThanks for installing §6Better Give Command by TrayePlays\n§eIf you need any assistance for the mod join the discord: §9discord.gg/GHzNqpZ4Bu`))

import { SuperStack } from "./superstack.js"

system.beforeEvents.startup.subscribe(({ customCommandRegistry }) => {
    const trayeGive = {
        name: "better:give",
        description: "Gives an item to a player but better.",
        permissionLevel: CommandPermissionLevel.GameDirectors,
        mandatoryParameters: [
            { type: CustomCommandParamType.PlayerSelector, name: "Player" },
            { type: CustomCommandParamType.ItemType, name: "Item Type" }
        ],
        optionalParameters: [
            { type: CustomCommandParamType.Integer, name: "Amount" },
            { type: CustomCommandParamType.Integer, name: "Data" },
            // { type: CustomCommandParamType.Integer, name: "Item Slot" },
            { type: CustomCommandParamType.String, name: "Name Tag" },
            { type: CustomCommandParamType.String, name: "Lore" },
            { type: CustomCommandParamType.Enum, name: "better:lockmode" },
            // { type: CustomCommandParamType.String, name: "Destroy Blocks?" },
            // { type: CustomCommandParamType.Enum, name: "better:equipmentSlot" },
            { type: CustomCommandParamType.String, name: "Enchantments" }
        ]
    };

    // customCommandRegistry.registerEnum("better:equipmentSlot", ["Head", "Chest", "Legs", "Feet", "Mainhand", "Offhand", "None"]);
    customCommandRegistry.registerEnum("better:lockmode", ["none", "slot", "inventory"]);
    customCommandRegistry.registerCommand(trayeGive, addItem);
});

/** @param {CustomCommandOrigin} origin  */
function addItem(origin, players, itemId, amount = 1, data = 0,  nameTag, lore, lockMode = ItemLockMode.none, 
    // equipmentSlot,
    enchantments = "[]") {
    system.run(() => {
        for (const player of players) {
            if (!player) {
                console.error("Player is undefined.");
                return {
                    status: CustomCommandStatus.Failure
                };
            }
            const item = new ItemStack(itemId, amount);
            const superStack = new SuperStack(item)
            try {
                const realEnchantments = JSON.parse(convertEnchantments(enchantments))
                if (realEnchantments.length > 0) {
                    for (const ench of realEnchantments) {
                        if (ench.type !== undefined) {
                            item.getComponent("enchantable")?.addEnchantment({ type: new EnchantmentType(ench.type), level: ench.level ?? 1 });
                        }
                    }
                }
            }
            catch (e) {
                origin?.sourceEntity.sendMessage(`§cError when trying to enchant! Make sure you type enchantments like §d"[{'type':'sharpness','level':5},{'type':'unbreaking','level':2}]" §6INCLUDE QUOTES`)
            }
            try {
                superStack.setData(data)
            }
            catch {
                origin?.sourceEntity.sendMessage(`§cError when trying to set data! §aAccepted Values: §2Numbers`)
            }
            try {
                superStack.itemStack.lockMode = lockMode;
            }
            catch {
                origin?.sourceEntity.sendMessage(`§cError when trying to set lock mode! §aAccepted Values: §6none, slot, inventory`)
            }
            if (nameTag.toLowerCase() == "none") {}
            else {
                superStack.itemStack.nameTag = nameTag;
            }
            try {
                if (lore.toLowerCase() == "none") {}
                else superStack.itemStack.setLore(convertLore(lore) ?? []);
            }
            catch {
                origin?.sourceEntity.sendMessage(`§cError when trying to set lore! Make sure you type lore like §d"lore line 1, lore line 2, lore line 3" §6INCLUDE QUOTES`)
            }
            // item.setCanDestroy(destroyBlocks ?? []);
            const inventory = player.getComponent("inventory");
            const equippable = player.getComponent("equippable");
            // try {
            inventory.container.addItem(superStack.itemStack)
            // else if (itemSlot !== undefined) inventory.container.setItem(itemSlot, item);
                // else if (equipmentSlot !== undefined) equippable.setEquipment(equipmentSlot, superStack.itemStack);
            // }
            // catch {
            //     origin?.sourceEntity.sendMessage(`§cError when trying to set equipment slot! §aAccepted Values: §6Head, Chest, Legs, Feet, Mainhand, Offhand, None`)
            // }
        
        }
    })
    return {
        status: CustomCommandStatus.Success
    };
}
/** @param {String} string  */
function convertLore(string) {
    if (string != undefined) {
        return string.split(",")
    }
}

/** @param {String} string  */
function convertEnchantments(string) {
    if (string != undefined) {
        string = string.replaceAll(",", "},{\"type\"√\"")
        string = string.replaceAll(":", "\", \"level\":")
        string = string.replaceAll("√", ":")
        string = "[{\"type\":\"" + string + "}]"
        string = string.replaceAll("'", `"`)
        console.warn(string)
        console.warn(JSON.parse(string)[0].type)
        return string
    }
}